
execute if score match_state game_state matches 1.. unless entity @a[team=blue,tag=has_flag] as @e[type=armor_stand,tag=red_flag] at @s unless entity @e[type=marker,tag=red_flag_spawn,distance=..0.01] if entity @a[team=red,distance=..0.8] run tag @s add return
execute if score match_state game_state matches 1.. unless entity @a[team=red,tag=has_flag] as @e[type=armor_stand,tag=blue_flag] at @s unless entity @e[type=marker,tag=blue_flag_spawn,distance=..0.01] if entity @a[team=blue,distance=..0.8] run tag @s add return
execute if entity @e[type=armor_stand,tag=return] run title @a[team=!lobby] times 0 40 10
execute as @e[type=armor_stand,tag=return] at @s run playsound minecraft:block.wooden_door.close block @a ~ ~ ~ 0.5 1.3
execute if entity @e[type=armor_stand,tag=return] as @a[team=!lobby] at @s run playsound minecraft:entity.ender_dragon.flap master @s ~ ~1 ~ 0.5 1.5
execute if entity @e[type=armor_stand,tag=return] run title @a[team=!lobby] title ""
execute if entity @e[type=armor_stand,tag=return,tag=red_flag] run title @a[team=!lobby] subtitle {"text":"Red Flag","color":"red","extra":[{"text":" was returned to the base","color":"gray"}]}
execute if entity @e[type=armor_stand,tag=return,tag=blue_flag] run title @a[team=!lobby] subtitle {"text":"Blue Flag","color":"blue","extra":[{"text":" was returned to the base","color":"gray"}]}

execute as @e[type=marker,tag=red_flag_spawn] at @s run kill @e[type=armor_stand,tag=land_mine,distance=..1]
execute as @e[type=marker,tag=red_flag_spawn] at @s run kill @e[type=armor_stand,tag=land_mine_display,distance=..1]

execute as @e[type=marker,tag=blue_flag_spawn] at @s run kill @e[type=armor_stand,tag=land_mine,distance=..1]
execute as @e[type=marker,tag=blue_flag_spawn] at @s run kill @e[type=armor_stand,tag=land_mine_display,distance=..1]

scoreboard players remove @a[scores={flag_cooldown=1..}] flag_cooldown 1
scoreboard players reset @a[scores={flag_cooldown=..0}] flag_cooldown

scoreboard players set @a[scores={death=1..}] flag_cooldown 20

execute if score match_state game_state matches 1.. unless entity @a[tag=has_flag,team=blue] as @e[type=armor_stand,tag=red_flag] at @s as @a[team=blue,distance=..1,sort=nearest,limit=1] unless score @s death matches 1.. run tag @s add pickup_flag
execute if score match_state game_state matches 1.. unless entity @a[tag=has_flag,team=red] as @e[type=armor_stand,tag=blue_flag] at @s as @a[team=red,distance=..1,sort=nearest,limit=1] unless score @s death matches 1.. run tag @s add pickup_flag
tag @a[tag=pickup_flag,scores={flag_cooldown=1..}] remove pickup_flag
execute if entity @a[tag=pickup_flag] run title @a[team=!lobby] times 0 40 10
execute if entity @a[tag=pickup_flag] run title @a[team=!lobby] title ""
execute as @a[tag=pickup_flag,team=red] run title @a[team=!lobby] subtitle {"selector":"@s","extra":[{"text":" picked up the ","color":"gray"},{"text":"Blue Flag","color":"blue"},{"text":"!","color":"gray"}]}
execute as @a[tag=pickup_flag,team=blue] run title @a[team=!lobby] subtitle {"selector":"@s","extra":[{"text":" picked up the ","color":"gray"},{"text":"Red Flag","color":"red"},{"text":"!","color":"gray"}]}
execute if entity @a[tag=pickup_flag,team=blue] as @a[team=blue] at @s run playsound minecraft:block.beacon.power_select master @s ~ ~1 ~ 0.6 2
execute if entity @a[tag=pickup_flag,team=blue] as @a[team=blue] at @s run playsound minecraft:block.beacon.power_select master @s ~ ~1 ~ 0.4 1.5
execute if entity @a[tag=pickup_flag,team=blue] as @a[team=blue] at @s run playsound minecraft:entity.generic.explode master @s ~ ~1 ~ 0.25 1.8
execute if entity @a[tag=pickup_flag,team=blue] as @a[team=!lobby,team=!blue] at @s run playsound minecraft:entity.wither.hurt master @s ~ ~1 ~ 0.3 1
execute if entity @a[tag=pickup_flag,team=red] as @a[team=red] at @s run playsound minecraft:block.beacon.power_select master @s ~ ~1 ~ 0.6 2
execute if entity @a[tag=pickup_flag,team=red] as @a[team=red] at @s run playsound minecraft:block.beacon.power_select master @s ~ ~1 ~ 0.4 1.5
execute if entity @a[tag=pickup_flag,team=red] as @a[team=red] at @s run playsound minecraft:entity.generic.explode master @s ~ ~1 ~ 0.25 1.8
execute if entity @a[tag=pickup_flag,team=red] as @a[team=!lobby,team=!red] at @s run playsound minecraft:entity.wither.hurt master @s ~ ~1 ~ 0.3 1

tag @a[tag=pickup_flag] add has_flag
tag @a[tag=pickup_flag] remove pickup_flag

execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},tag=has_flag] run title @a[team=!lobby] times 0 40 10
execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},tag=has_flag] run title @a[team=!lobby] title ""
execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},tag=has_flag,team=red] run title @a[team=!lobby] subtitle {"text":"Blue Flag","color":"blue","extra":[{"text":" was dropped!","color":"gray"}]}
execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},tag=has_flag,team=blue] run title @a[team=!lobby] subtitle {"text":"Red Flag","color":"red","extra":[{"text":" was dropped!","color":"gray"}]}
execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},tag=has_flag] as @a[team=!lobby] at @s run playsound minecraft:entity.zombie.break_wooden_door master @s ~ ~1 ~ 0.2 1.6
tag @a[scores={flag_cooldown=1..},tag=has_flag] remove has_flag


execute if score match_state game_state matches 1.. as @e[type=armor_stand,tag=red_flag] at @s if entity @e[type=marker,tag=red_flag_spawn,distance=..0.01] run tag @a[team=red,distance=..1,tag=has_flag] add flag_point
execute if score match_state game_state matches 1.. as @e[type=armor_stand,tag=blue_flag] at @s if entity @e[type=marker,tag=blue_flag_spawn,distance=..0.01] run tag @a[team=blue,distance=..1,tag=has_flag] add flag_point
execute if entity @a[tag=flag_point] run title @a[team=!lobby] times 0 40 10
execute if entity @a[tag=flag_point] run title @a[team=!lobby] title ""
execute if entity @a[tag=flag_point,team=red] run title @a[team=!lobby] subtitle {"text":"Red Team","color":"red","extra":[{"text":" scored a point!","color":"gray"}]}
execute if entity @a[tag=flag_point,team=blue] run title @a[team=!lobby] subtitle {"text":"Blue Team","color":"blue","extra":[{"text":" scored a point!","color":"gray"}]}
execute as @a[tag=flag_point,team=red] run tellraw @a[team=!lobby] {"text":"[","color":"gray","extra":[{"text":"⚑ ","color":"blue"},{"selector":"@s"},{"text":"]"}]}
execute as @a[tag=flag_point,team=blue] run tellraw @a[team=!lobby] {"text":"[","color":"gray","extra":[{"text":"⚑ ","color":"red"},{"selector":"@s"},{"text":"]"}]}
execute as @a[tag=flag_point,team=red] run scoreboard players add Red points 1
execute as @a[tag=flag_point,team=blue] run scoreboard players add Blue points 1
execute unless score Red points >= score_target game_state if entity @a[tag=flag_point,team=red] as @a[team=!lobby,team=!blue] at @s run playsound minecraft:entity.player.levelup master @s ~ ~1 ~ 0.5 0.8
execute unless score Red points >= score_target game_state if entity @a[tag=flag_point,team=red] as @a[team=!lobby,team=!blue] at @s run playsound minecraft:entity.player.levelup master @s ~ ~1 ~ 0.5 1.6
execute unless score Red points >= score_target game_state if entity @a[tag=flag_point,team=red] as @a[team=!lobby,team=!blue] at @s run playsound minecraft:entity.evoker.prepare_summon master @s ~ ~1 ~ 0.8 1.7
execute unless score Red points >= score_target game_state if entity @a[tag=flag_point,team=red] as @a[team=!lobby,team=blue] at @s run playsound minecraft:entity.wither.spawn master @s ~ ~1 ~ 0.25 2
execute unless score Red points >= score_target game_state if entity @a[tag=flag_point,team=blue] as @a[team=!lobby,team=!red] at @s run playsound minecraft:entity.player.levelup master @s ~ ~1 ~ 0.5 0.8
execute unless score Red points >= score_target game_state if entity @a[tag=flag_point,team=blue] as @a[team=!lobby,team=!red] at @s run playsound minecraft:entity.player.levelup master @s ~ ~1 ~ 0.5 1.6
execute unless score Red points >= score_target game_state if entity @a[tag=flag_point,team=blue] as @a[team=!lobby,team=!red] at @s run playsound minecraft:entity.evoker.prepare_summon master @s ~ ~1 ~ 0.8 1.7
execute unless score Red points >= score_target game_state if entity @a[tag=flag_point,team=blue] as @a[team=!lobby,team=red] at @s run playsound minecraft:entity.wither.spawn master @s ~ ~1 ~ 0.25 2
execute unless score Red points >= score_target game_state if entity @a[tag=flag_point] as @a[team=!lobby] at @s run playsound minecraft:entity.generic.explode master @s ~ ~1 ~ 0.25 1.5
execute if entity @a[tag=flag_point,team=blue] run tp @e[type=armor_stand,tag=red_flag] @e[type=marker,tag=red_flag_spawn,limit=1]
execute if entity @a[tag=flag_point,team=red] run tp @e[type=armor_stand,tag=blue_flag] @e[type=marker,tag=blue_flag_spawn,limit=1]

execute as @e[type=armor_stand,tag=red_flag] at @s if entity @e[type=marker,tag=red_flag_spawn,distance=..0.2] run tp @s @e[type=marker,tag=red_flag_spawn,limit=1,sort=nearest]
execute as @e[type=armor_stand,tag=blue_flag] at @s if entity @e[type=marker,tag=blue_flag_spawn,distance=..0.2] run tp @s @e[type=marker,tag=blue_flag_spawn,limit=1,sort=nearest]

tag @a[tag=flag_point] remove has_flag
tag @a[tag=flag_point] remove flag_point

execute if entity @e[type=armor_stand,tag=return,tag=red_flag] as @a[team=!red,team=!lobby] at @s run playsound minecraft:block.note_block.bass block @s ~ ~1 ~ 0.5 1
execute if entity @e[type=armor_stand,tag=return,tag=red_flag] as @a[team=red] at @s run playsound minecraft:entity.experience_orb.pickup block @s ~ ~1 ~ 0.3 1.5
execute if entity @e[type=armor_stand,tag=return,tag=blue_flag] as @a[team=!blue,team=!lobby] at @s run playsound minecraft:block.note_block.bass block @s ~ ~1 ~ 0.5 1
execute if entity @e[type=armor_stand,tag=return,tag=blue_flag] as @a[team=blue] at @s run playsound minecraft:entity.experience_orb.pickup block @s ~ ~1 ~ 0.3 1.5

execute if entity @e[type=armor_stand,tag=return,tag=red_flag] run tp @e[type=armor_stand,tag=red_flag] @e[type=marker,tag=red_flag_spawn,limit=1]
execute if entity @e[type=armor_stand,tag=return,tag=blue_flag] run tp @e[type=armor_stand,tag=blue_flag] @e[type=marker,tag=blue_flag_spawn,limit=1]
tag @e[tag=return] remove return


execute as @e[type=armor_stand,tag=red_flag_display] at @e[type=armor_stand,tag=red_flag,limit=1] positioned ^ ^ ^0.3 run tp @s ~ ~-1.77 ~ ~ ~
execute as @e[type=armor_stand,tag=blue_flag_display] at @e[type=armor_stand,tag=blue_flag,limit=1] positioned ^ ^ ^0.3 run tp @s ~ ~-1.77 ~ ~ ~
execute as @e[type=armor_stand,tag=red_flag_display] at @s positioned ^ ^ ^-0.28 run particle falling_dust red_concrete ~ ~1.85 ~ 0 0 0 0 1
execute as @e[type=armor_stand,tag=blue_flag_display] at @s positioned ^ ^ ^-0.28 run particle falling_dust blue_concrete ~ ~1.85 ~ 0 0 0 0 1



execute if entity @a[tag=has_flag,team=red] run kill @e[type=armor_stand,tag=blue_flag_entity]
execute if entity @a[tag=has_flag,team=blue] run kill @e[type=armor_stand,tag=red_flag_entity]
execute unless entity @e[type=armor_stand,tag=red_flag_display] as @e[type=armor_stand,tag=red_flag,limit=1] at @s positioned ^ ^ ^0.3 run summon armor_stand ~ ~-1.77 ~ {Glowing:1b,Tags:["red_flag_display","red_flag_entity"],Invisible:1,Invulnerable:1,NoGravity:1,DisabledSlots:4144896,NoBasePlate:1,Marker:1,Silent:1,ArmorItems:[{},{},{},{id:"minecraft:red_banner",Count:1,tag:{BlockEntityTag:{Patterns:[{Pattern:"gru",Color:6}]},HideFlags:32}}]}
execute unless entity @e[type=armor_stand,tag=blue_flag_display] as @e[type=armor_stand,tag=blue_flag,limit=1] at @s positioned ^ ^ ^0.3 run summon armor_stand ~ ~-1.77 ~ {Glowing:1b,Tags:["blue_flag_display","blue_flag_entity"],Invisible:1,Invulnerable:1,NoGravity:1,DisabledSlots:4144896,NoBasePlate:1,Marker:1,Silent:1,ArmorItems:[{},{},{},{id:"minecraft:blue_banner",Count:1,tag:{BlockEntityTag:{Patterns:[{Pattern:"gru",Color:3}]},HideFlags:32}}]}
team join red @e[type=armor_stand,tag=red_flag_display,team=]
team join blue @e[type=armor_stand,tag=blue_flag_display,team=]
execute if score match_state game_state matches 1.. as @e[type=armor_stand,tag=red_flag] at @s unless entity @e[type=marker,tag=red_flag_spawn,distance=..0.01] run particle instant_effect ~ ~0.7 ~ 0.3 0.5 0.3 0 1 normal @a[team=red]
execute if score match_state game_state matches 1.. as @e[type=armor_stand,tag=red_flag] at @s if entity @e[type=marker,tag=red_flag_spawn,distance=..0.01] run particle instant_effect ~ ~0.7 ~ 0.3 0.5 0.3 0 1 normal @a[team=red,tag=has_flag]
execute if score match_state game_state matches 1.. as @e[type=armor_stand,tag=red_flag] at @s run particle instant_effect ~ ~0.7 ~ 0.3 0.5 0.3 0 1 normal @a[team=!red]
execute if score match_state game_state matches 1.. as @e[type=armor_stand,tag=blue_flag] at @s unless entity @e[type=marker,tag=blue_flag_spawn,distance=..0.01] run particle instant_effect ~ ~0.7 ~ 0.3 0.5 0.3 0 1 normal @a[team=blue]
execute if score match_state game_state matches 1.. as @e[type=armor_stand,tag=blue_flag] at @s if entity @e[type=marker,tag=blue_flag_spawn,distance=..0.01] run particle instant_effect ~ ~0.7 ~ 0.3 0.5 0.3 0 1 normal @a[team=blue,tag=has_flag]
execute if score match_state game_state matches 1.. as @e[type=armor_stand,tag=blue_flag] at @s run particle instant_effect ~ ~0.7 ~ 0.3 0.5 0.3 0 1 normal @a[team=!blue]
execute as @e[type=armor_stand,tag=red_flag,nbt={Marker:1b}] run data merge entity @s {Marker:0}
execute as @e[type=armor_stand,tag=blue_flag,nbt={Marker:1b}] run data merge entity @s {Marker:0}
execute as @a[tag=has_flag,team=red] at @s run summon armor_stand ~ ~ ~ {Tags:["blue_flag","blue_flag_entity"],Invisible:1,Invulnerable:1,Small:1,DisabledSlots:4144896,NoBasePlate:1,Silent:1,PersistenceRequired:1,Marker:1b}
execute as @a[tag=has_flag,team=red] at @s run tp @e[type=armor_stand,tag=blue_flag] @s
execute as @a[tag=has_flag,team=blue] at @s run summon armor_stand ~ ~ ~ {Tags:["red_flag","red_flag_entity"],Invisible:1,Invulnerable:1,Small:1,DisabledSlots:4144896,NoBasePlate:1,Silent:1,PersistenceRequired:1,Marker:1b}
execute as @a[tag=has_flag,team=blue] at @s run tp @e[type=armor_stand,tag=red_flag] @s



effect give @a[tag=has_flag] glowing infinite 0 true
effect clear @a[tag=!has_flag] glowing
execute unless score match_state game_state matches 1.. run tag @a[tag=has_flag] remove has_flag

execute if score Red points >= score_target game_state run tag @a[team=red] add winner
execute if score Blue points >= score_target game_state run tag @a[team=blue] add winner