execute as @e[type=snowball,tag=registered] at @s run particle smoke ~ ~.05 ~ 0 0 0 0 1

execute as @e[type=snowball] unless score @s entity_id matches 1.. run kill @s
execute as @e[type=snowball,tag=!registered] at @s run summon marker ~ ~ ~ {Tags:["smoke_tracker"]}
execute as @e[type=marker,tag=smoke_tracker] unless score @s entity_id matches 1.. at @s as @e[type=snowball,sort=nearest,tag=!registered,limit=1] run scoreboard players operation @e[type=marker,tag=smoke_tracker,sort=nearest,limit=1] entity_id = @s entity_id
tag @e[type=snowball,tag=!registered] add registered
execute as @e[type=snowball] at @s as @e[type=marker,tag=smoke_tracker] if score @s entity_id = @e[type=snowball,sort=nearest,limit=1] entity_id run tp @s @e[type=snowball,sort=nearest,limit=1]
scoreboard players add @e[type=marker,tag=smoke_tracker] display_timer 1
execute as @e[type=marker,tag=smoke_tracker] at @s as @e[type=snowball] if score @s entity_id = @e[type=marker,tag=smoke_tracker,sort=nearest,limit=1] entity_id run scoreboard players set @e[type=marker,tag=smoke_tracker,sort=nearest,limit=1] display_timer -1
kill @e[type=marker,tag=smoke_tracker,scores={display_timer=100..}]

execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0..}] run scoreboard players operation @s sound_timer = @s display_timer
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0..}] run scoreboard players operation @s sound_timer %= smoke_sound_rate constants
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0}] at @s run playsound minecraft:entity.generic.extinguish_fire neutral @a ~ ~ ~ 0.5 0.5
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0}] at @s run playsound minecraft:entity.zombie_villager.cure neutral @a ~ ~1 ~ 0.3 1.5
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0..,sound_timer=0}] at @s run playsound minecraft:entity.generic.extinguish_fire neutral @a ~ ~ ~ 0.05 0.52
execute as @a[tag=smoke_blind] at @s unless entity @e[type=marker,tag=smoke_tracker,scores={display_timer=0..},distance=..3] run effect clear @s minecraft:blindness
execute as @a[tag=smoke_blind] at @s unless entity @e[type=marker,tag=smoke_tracker,scores={display_timer=0..},distance=..3] run effect clear @s minecraft:slowness
execute as @a[tag=smoke_blind] at @s unless entity @e[type=marker,tag=smoke_tracker,scores={display_timer=0..},distance=..3] run effect give @s minecraft:blindness 1 0 true
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0..}] at @s as @a[gamemode=!spectator,distance=..3,tag=!smoke_blind,tag=!needs_revival] at @s run playsound minecraft:entity.zombie.infect neutral @s ~ ~1 ~ 0.6 0.7
tag @a[tag=smoke_blind] remove smoke_blind
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0..}] at @s run tag @a[gamemode=!spectator,distance=..3,tag=!needs_revival] add smoke_blind
effect give @a[tag=smoke_blind] minecraft:blindness infinite 0 true
effect give @a[tag=smoke_blind] minecraft:slowness infinite 2 true
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0..,sound_timer=0}] at @s run particle minecraft:explosion_emitter ~ ~1 ~ 1.5 1 1.5 0 1 force
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0..}] at @s run particle minecraft:explosion_emitter ~ ~1 ~ 1.5 1 1.5 0 1
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0..}] at @s run particle minecraft:poof ~ ~0.5 ~ 1.2 1.2 1.2 0.1 10
execute as @e[type=marker,tag=smoke_tracker,scores={display_timer=0..}] at @s run particle minecraft:large_smoke ~ ~0.5 ~ 0.8 0.8 0.8 0.1 2